package increasemobs.client;

import java.util.List;

import com.google.common.collect.Lists;

import increasemobs.core.Config;
import increasemobs.core.IncreaseMobs;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.resources.I18n;
import net.minecraftforge.common.config.ConfigElement;
import net.minecraftforge.fml.client.config.DummyConfigElement.DummyCategoryElement;
import net.minecraftforge.fml.client.config.GuiConfig;
import net.minecraftforge.fml.client.config.GuiConfigEntries;
import net.minecraftforge.fml.client.config.GuiConfigEntries.CategoryEntry;
import net.minecraftforge.fml.client.config.IConfigElement;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class IncreaseConfigGui extends GuiConfig
{
	public IncreaseConfigGui(GuiScreen parent)
	{
		super(parent, getConfigElements(),  IncreaseMobs.MODID, false, false, I18n.format(IncreaseMobs.CONFIG_LANG + "title"));
	}

	private static List<IConfigElement> getConfigElements()
	{
		List<IConfigElement> list = Lists.newArrayList();

		list.add(new IncreaseCategoryElement("monster", MonsterEntry.class));
		list.add(new IncreaseCategoryElement("ambient", AmbientEntry.class));
		list.add(new IncreaseCategoryElement("waterCreature", WaterCreatureEntry.class));

		return list;
	}

	public static class IncreaseCategoryElement extends DummyCategoryElement
	{
		public IncreaseCategoryElement(String name, Class clazz)
		{
			super(IncreaseMobs.MODID  + "@" + name + "Cfg", IncreaseMobs.CONFIG_LANG  + name, clazz);
		}
	}

	public static class MonsterEntry extends CategoryEntry
	{
		public MonsterEntry(GuiConfig owningScreen, GuiConfigEntries owningEntryList, IConfigElement prop)
		{
			super(owningScreen, owningEntryList, prop);
		}

		@Override
		protected GuiScreen buildChildScreen()
		{
			return new GuiConfig(owningScreen, new ConfigElement(Config.config.getCategory("monster")).getChildElements(),
				owningScreen.modID, "monster", this.configElement.requiresWorldRestart() || owningScreen.allRequireWorldRestart,
				configElement.requiresMcRestart() || owningScreen.allRequireMcRestart, GuiConfig.getAbridgedConfigPath(Config.config.toString()));
		}
	}

	public static class AmbientEntry extends CategoryEntry
	{
		public AmbientEntry(GuiConfig owningScreen, GuiConfigEntries owningEntryList, IConfigElement prop)
		{
			super(owningScreen, owningEntryList, prop);
		}

		@Override
		protected GuiScreen buildChildScreen()
		{
			return new GuiConfig(owningScreen, new ConfigElement(Config.config.getCategory("ambient")).getChildElements(),
				owningScreen.modID, "ambient", this.configElement.requiresWorldRestart() || owningScreen.allRequireWorldRestart,
				configElement.requiresMcRestart() || owningScreen.allRequireMcRestart, GuiConfig.getAbridgedConfigPath(Config.config.toString()));
		}
	}

	public static class WaterCreatureEntry extends CategoryEntry
	{
		public WaterCreatureEntry(GuiConfig owningScreen, GuiConfigEntries owningEntryList, IConfigElement prop)
		{
			super(owningScreen, owningEntryList, prop);
		}

		@Override
		protected GuiScreen buildChildScreen()
		{
			return new GuiConfig(owningScreen, new ConfigElement(Config.config.getCategory("waterCreature")).getChildElements(),
				owningScreen.modID, "waterCreature", this.configElement.requiresWorldRestart() || owningScreen.allRequireWorldRestart,
				configElement.requiresMcRestart() || owningScreen.allRequireMcRestart, GuiConfig.getAbridgedConfigPath(Config.config.toString()));
		}
	}
}